<?php

/**
 * remision_titulo_det actions.
 *
 * @package    cobro_coactivo
 * @subpackage remision_titulo_det
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class remision_titulo_detActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_REMISION_TITULO_DET_V',
        'CBR_PAR',
        'CBR_APRUEBA_REPARTO_ULT_V',
        'CBR_APROB_DENEG_ULT_V',
        'CBR_ABOGADO_ULT_V',
        'CBR_RESOL_TIT_REMIS_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_PAR' =>
        array(
            'id_par' => 'CBR_REMISION_TITULO_DET_V'
        ),
        'CBR_APRUEBA_REPARTO_ULT_V,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_REMISION_TITULO_DET_V'
        ),
        'CBR_APROB_DENEG_ULT_V,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_REMISION_TITULO_DET_V'
        ),
        'CBR_ABOGADO_ULT_V,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_REMISION_TITULO_DET_V'
        ),
        'CBR_RESOL_TIT_REMIS_V,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_REMISION_TITULO_DET_V'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_REMISION_TITULO_DET_V' =>
        array(
            'id_remision_titulo_det' => 'id_remision_titulo_det',
            'id_remision_titulo' => 'id_remision_titulo',
            'cod_titulo' => 'cod_titulo',
            'observaciones' => 'observaciones',
            'fecha_log' => 'fecha_log',
            'usuario_log' => 'usuario_log',
            'mineral' => 'mineral',
            'cod_mineral' => 'cod_mineral',
            'id_mineral' => 'id_mineral',
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'numero_correpondencia' => 'numero_correpondencia',
            'fecha_remision' => 'fecha_remision',
            'id_par' => 'id_par',
            'no_folios' => 'no_folios',
            'estado' => 'estado',
            'numero_remision,||, - ,||,anho_remision' => 'completo_remision'
        ),
        'CBR_PAR' =>
        array(
            'descripcion' => 'descripcion_par'
        ),
        'CBR_APRUEBA_REPARTO_ULT_V' =>
        array(
            'aprobado' => 'aprobado_rep'
        ),
        'CBR_APROB_DENEG_ULT_V' =>
        array(
            'aprobado' => 'aprobado_deneg'
        ),
        'CBR_ABOGADO_ULT_V' =>
        array(
            'id_abogado' => 'id_abogado',
            'num_doc' => 'num_doc',
            'razon_soc' => 'razon_soc'
        ),
        'CBR_RESOL_TIT_REMIS_V' =>
        array(
            'no_resolucion' => 'no_resolucion',
            'date_expedicion' => 'date_expedicion',
            'no_resolucion_det' => 'no_resolucion_det',
            'date_expedicion_det' => 'date_expedicion_det',
            'no_resolucion_text' => 'no_resolucion_text',
            'date_expedicion_text' => 'date_expedicion_text',
            'no_resolucion_text_completa' => 'no_resolucion_text_completa',
            'valor_capital' => 'valor_capital',
            'valor_interes' => 'valor_interes',
            'valor_abono' => 'valor_abono',
            'saldo' => 'saldo',
            'valor_abono_calc' => 'valor_abono_calc',
            'valor_acuerdo' => 'valor_acuerdo',
            'valor_embargo' => 'valor_embargo'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'anho_remision', 'numero_remision', 'cod_titulo', 'fecha_log'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     * IN - where de in de oracle, para numero
     * INTEXT - where de in de oracle, para texto
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_REMISION_TITULO_DET_V' =>
        array(
            'id_remision_titulo_det,a' => array('!=' => array(-1)),
            'id_remision_titulo_det,b' => array('=' => array('id_remision_titulo_det')),
            'id_remision_titulo' => array('=' => array('id_remision_titulo')),
            'cod_titulo' => array('=' => array('cod_titulo')),
            'id_par' => array('=' => array('id_par')),
            'numero_remision' => array('=' => array('numero_remision')),
            'anho_remision' => array('=' => array('anho_remision')),
            'numero_correpondencia' => array('=' => array('numero_correpondencia')),
            'fecha_remision' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_remision_titulo_det'; //identificador de la tabla
    protected $id_names = array('id_remision_titulo_det'); //llave primaria
    protected $field_names = array('id_remision_titulo', 'cod_titulo', 'observaciones', 'usuario_log'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_REMISION_TITULO_DET'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_remision_titulo_det'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {

        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $request['usuario_log'] = $request['id_username'];
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
        $id_remision_titulo = $request['id_remision_titulo'];
        $cod_titulo = $request['cod_titulo'];

        $sql = <<<EOD
SELECT
    *
FROM cbr_remision_titulo_det
where
id_remision_titulo = $id_remision_titulo
and cod_titulo = '$cod_titulo' 
EOD;
        $record = CN_TABLE::executeSQL($sql);

        /*
         *  Generar errores en $errors
         */
        if (count($record) > 0) {
            $errors['mensaje'] = "NO puede registrarse el mismo Titulo a la recepción.";
            $errors['servicio'] = "remision_titulo_det";
        }

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
        $id_remision_titulo = $request['id_remision_titulo'];
        $cod_titulo = $request['cod_titulo'];
        $id_remision_titulo_det = $request['id_remision_titulo_det'];

        $sql = <<<EOD
SELECT
    *
FROM cbr_remision_titulo_det
where
id_remision_titulo = $id_remision_titulo
and cod_titulo = '$cod_titulo' 
and id_remision_titulo_det != $id_remision_titulo_det                  
EOD;
        $record = CN_TABLE::executeSQL($sql);

        /*
         *  Generar errores en $errors
         */
        if (count($record) > 0) {
            $errors['mensaje'] = "NO puede actualizarce el Titulo a la recepción.";
            $errors['servicio'] = "remision_titulo_det";
        }

        return $errors;
    }

}
